## Controller Python Script "Workgroup_local_roles_action"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind state=state
##bind subpath=traverse_subpath
##parameters=memberids_localroles_new=None, memberids_localroles_old=None
##title=Update local roles in a workgroup
##

# make shure memberids_localroles is a list
if memberids_localroles_new is None:
    memberids_localroles_new = []

if memberids_localroles_old is None:
    memberids_localroles_old = []
    
# build: old_map = {memberid:[old_local_roles]]]
old_map = {}
for ml in memberids_localroles_old:
    # parse input
    splitter = ml.find('/')
    # build dict
    memberid, localrole = ml[:splitter], ml[splitter+1:]
    old_map.setdefault(memberid, []).append(localrole)

# build: new_map = {memberid:[new_local_roles]]]
new_map = {}
for ml in memberids_localroles_new:
    # parse input
    splitter = ml.find('/')
    # build dict
    memberid, localrole = ml[:splitter], ml[splitter+1:]
    new_map.setdefault(memberid, []).append(localrole)

# get the workgroup
workgroup = context.getWorkgroup()
member_ids = [m.getMemberId() for m in workgroup.getGroupMembers()]


# do the local role changes
for member_id in member_ids:
    new_local_roles = new_map.get(member_id, [])
    old_local_roles = old_map.get(member_id, [])
    if new_local_roles != old_local_roles:
        workgroup.updateLocalroles(member_id, old_local_roles, new_local_roles)


try: # new cmf
    from Products.Archetypes import transaction_note
except:
	from Products.CMFPlone import transaction_note
transaction_note('Updated local roles in workgroup %s at %s' % (context.title_or_id(), context.absolute_url()))

state.setNextAction('traverse_to:string:Workgroup_local_roles')

message='Local roles updated'

return state.set(context=context, portal_status_message=message)